<?php
/**
 * Clase Base FN para BaseRhPensionFN
 *
 * @package    
 * @subpackage BaseRhPensionFN
 * @author     Willy
 * @version    SVN:: BaseRhPensionFN.class.php,v 1.1 2015-01-25 15:09:49 william.taype Exp $
 */
class BaseRhPensionFN extends RhPensionBN
{
  private static $fieldNames = array (
    'IdPension'=>'IdPension', 'Descripcion'=>'Descripcion', 'Tipo'=>'Tipo', 'Estado'=>'Estado', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro', 'Eliminado'=>'Eliminado', 'Fechaeliminado'=>'fechaeliminado', 'Usuarioeliminado'=>'usuarioeliminado', 'FechaModificacion'=>'fechaModificacion', 'UsuarioModificacion'=>'usuarioModificacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT IdPension, Descripcion, Tipo, Estado, fecharegistro, usuarioregistro, Eliminado, fechaeliminado, usuarioeliminado, fechaModificacion, usuarioModificacion FROM rh_pension WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
       $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT IdPension, Descripcion, Tipo, Estado, fecharegistro, usuarioregistro, Eliminado, fechaeliminado, usuarioeliminado, fechaModificacion, usuarioModificacion FROM rh_pension WHERE 1 ".$where;
	 
        
      $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
        
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdPension()){ $where .= " AND idpension = '".$this->getIdPension()."'"; }
      if($this->getDescripcion()){ $where .= " AND descripcion = '".$this->getDescripcion()."'"; }
      if($this->getTipo()){ $where .= " AND tipo = '".$this->getTipo()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getFechaeliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaeliminado()."'"; }
      if($this->getUsuarioeliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioeliminado()."'"; }
      if($this->getFechaModificacion()){ $where .= " AND fechamodificacion = '".$this->getFechaModificacion()."'"; }
      if($this->getUsuarioModificacion()){ $where .= " AND usuariomodificacion = '".$this->getUsuarioModificacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdPension, Descripcion, Tipo, Estado, fecharegistro, usuarioregistro, Eliminado, fechaeliminado, usuarioeliminado, fechaModificacion, usuarioModificacion FROM rh_pension WHERE 1 AND IdPension='".$this->getIdPension()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseRhPensionFN = new BaseRhPensionFN();
    $o_BaseRhPensionFN->setIdPension($o_propel->IdPension);
    $o_BaseRhPensionFN->setDescripcion($o_propel->Descripcion);
    $o_BaseRhPensionFN->setTipo($o_propel->Tipo);
    $o_BaseRhPensionFN->setEstado($o_propel->Estado);
    $o_BaseRhPensionFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseRhPensionFN->setUsuarioregistro($o_propel->usuarioregistro);
    $o_BaseRhPensionFN->setEliminado($o_propel->Eliminado);
    $o_BaseRhPensionFN->setFechaeliminado($o_propel->fechaeliminado);
    $o_BaseRhPensionFN->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_BaseRhPensionFN->setFechaModificacion($o_propel->fechaModificacion);
    $o_BaseRhPensionFN->setUsuarioModificacion($o_propel->usuarioModificacion);
    return $o_BaseRhPensionFN;
  }
}